/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "../SSSLib/SSSSmallMat.h"
#include <vector>

namespace BuildUtil
{
	void BuildTable(
		int iSW,
		int iSL,
		int iSH,
		int iLL,
		int iLT,
		int iLDL,
		int iLDW,
		std::vector<SSSLib::Vec3i>& oTable);

	void BuildSingleStand(
		int iSW,
		int iSL,
		int iSH,
		int iLL,
		int iLT,
		std::vector<SSSLib::Vec3i>& oTable);

	void BuildTwoStand(
		int iSW,
		int iSL,
		int iSH,
		int iLL,
		int iLT,
		int iLD,
		std::vector<SSSLib::Vec3i>& oTable);

}