/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "OGLTexture.h"
#include "OGLScene.h"
#include "../SSSSmallVec.h"

namespace SSSLib
{

class OGLTextureDisplay: public OGLScene::OGLDisplay
{
public:
	OGLTextureDisplay(void)
		: mUsingPt(false)
		, mTop(1)
		, mLeft(-1)
		, mButton(-1)
		, mRight(1)
	{}
	~OGLTextureDisplay(void){}

	OGLTexture2D mTex;
	virtual void DisplayFunc();
	
	float mTop;
	float mLeft;
	float mButton;
	float mRight;

	Vec2f mPt[4];
	bool mUsingPt;
};
}