/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/*
#include "SSSNURBS.h"
#include "SSSFunc.h"

using namespace SSSLib;
using namespace std;

SSSNURBS::SSSNURBS(void)
{
}

void SSSNURBS::SetDegree(int iDegree)
{
	mMaxDegree = iDegree;
}

void SSSNURBS::GenerateParam()
{
	mParam.clear();
	mParam.resize(mCtrPt.size(), vector<float>(mMaxDegree+1));
	for (int i=0; i<(int)mCtrPt.size(); i++)
		mParam[i][0] = mCtrPt[i][1];
	for (int n=1; n<=mMaxDegree; n++)
	for (int i=0; i<(int)mCtrPt.size()-n; i++)
	{
		vector<float> lasi = mParam[i];
		float scale;
		float offset0;;
		float offset1;
		if (i+1!=mCrtPt.size())
		{
			scale = 1.0f/(mCrtPt[i+1][0]-mCrtPt[i][0]);
			offset1 = scale*mCrtPt[i+1][0];
		}
		else
		{
			scale = 0;
			offset1 = 0;
		}
		offset0 = -scale*mCrtPt[i][0];
		mParam[i].assign(mParam[i].size(), 0);
		for (int nn = 0; nn < n-1; nn++)
		{
			mParam[i][nn] += offset0*lasi[nn];
			mParam[i][nn+1] += scale*lasi[nn];
			if (i+1 != mCrtPt.size())
			{
				mParam[i][nn] += offset1*mParam[i+1][nn];
				mParam[i][nn+1] += -scale*mParam[i+1][nn];
			}
		}
	}
}
*/