/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "../StaticFEM/Config.h"

struct KKTEle
{
	typedef std::pair<int, _T_FLOAT> KKTCoe;
	std::vector<KKTCoe> mACoes;
	_T_FLOAT mB;
	KKTEle(): mB(0), mACoes(0){}
	KKTEle(const KKTEle& iKKTEle): mB(iKKTEle.mB), mACoes(iKKTEle.mACoes){}
	void AddACoe(int iIdx, _T_FLOAT iVal){mACoes.push_back(KKTCoe(iIdx, iVal));}
};
