/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "XNodeVM.h"
#include "Static2DADMM.h"

using namespace ADMMLib;


XNodeVM::XNodeVM(void)
	: XNode(1)
{
}

XNodeVM::~XNodeVM(void)
{
}

void XNodeVM::SolveX()
{
	_T_FLOAT maxVM = mpADMMStatic2D->mMaxVM*mpADMMStatic2D->mVMScale;
	if (mpADMMStatic2D->mMaxVM>0 && m_n[0]>maxVM)
	{
		m_x[0] = maxVM;
		m_rhoOut[0] = mpADMM->mRho;
	}
	else
	{
		m_x[0] = m_n[0];
		m_rhoOut[0] = 0;
	}
}