/*
 * MATLAB Compiler: 5.1 (R2014a)
 * Date: Mon Nov 03 16:30:11 2014
 * Arguments: "-B" "macro_default" "-W" "lib:TOMLAB_export" "-T" "link:lib"
 * "TOMLAB_export" "nlp_cdcS" "nlp_fg" "ktr_grad" 
 */

#include <stdio.h>
#define EXPORTING_TOMLAB_export 1
#include "TOMLAB_export.h"

static HMCRINSTANCE _mcr_inst = NULL;


#if defined( _MSC_VER) || defined(__BORLANDC__) || defined(__WATCOMC__) || defined(__LCC__)
#ifdef __LCC__
#undef EXTERN_C
#endif
#include <windows.h>

static char path_to_dll[_MAX_PATH];

BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, void *pv)
{
    if (dwReason == DLL_PROCESS_ATTACH)
    {
        if (GetModuleFileName(hInstance, path_to_dll, _MAX_PATH) == 0)
            return FALSE;
    }
    else if (dwReason == DLL_PROCESS_DETACH)
    {
    }
    return TRUE;
}
#endif
#ifdef __cplusplus
extern "C" {
#endif

static int mclDefaultPrintHandler(const char *s)
{
  return mclWrite(1 /* stdout */, s, sizeof(char)*strlen(s));
}

#ifdef __cplusplus
} /* End extern "C" block */
#endif

#ifdef __cplusplus
extern "C" {
#endif

static int mclDefaultErrorHandler(const char *s)
{
  int written = 0;
  size_t len = 0;
  len = strlen(s);
  written = mclWrite(2 /* stderr */, s, sizeof(char)*len);
  if (len > 0 && s[ len-1 ] != '\n')
    written += mclWrite(2 /* stderr */, "\n", sizeof(char));
  return written;
}

#ifdef __cplusplus
} /* End extern "C" block */
#endif

/* This symbol is defined in shared libraries. Define it here
 * (to nothing) in case this isn't a shared library. 
 */
#ifndef LIB_TOMLAB_export_C_API
#define LIB_TOMLAB_export_C_API /* No special import/export declaration */
#endif

LIB_TOMLAB_export_C_API 
bool MW_CALL_CONV TOMLAB_exportInitializeWithHandlers(
    mclOutputHandlerFcn error_handler,
    mclOutputHandlerFcn print_handler)
{
    int bResult = 0;
  if (_mcr_inst != NULL)
    return true;
  if (!mclmcrInitialize())
    return false;
  if (!GetModuleFileName(GetModuleHandle("TOMLAB_export"), path_to_dll, _MAX_PATH))
    return false;
    {
        mclCtfStream ctfStream = 
            mclGetEmbeddedCtfStream(path_to_dll);
        if (ctfStream) {
            bResult = mclInitializeComponentInstanceEmbedded(   &_mcr_inst,
                                                                error_handler, 
                                                                print_handler,
                                                                ctfStream);
            mclDestroyStream(ctfStream);
        } else {
            bResult = 0;
        }
    }  
    if (!bResult)
    return false;
  return true;
}

LIB_TOMLAB_export_C_API 
bool MW_CALL_CONV TOMLAB_exportInitialize(void)
{
  return TOMLAB_exportInitializeWithHandlers(mclDefaultErrorHandler, 
                                             mclDefaultPrintHandler);
}

LIB_TOMLAB_export_C_API 
void MW_CALL_CONV TOMLAB_exportTerminate(void)
{
  if (_mcr_inst != NULL)
    mclTerminateInstance(&_mcr_inst);
}

LIB_TOMLAB_export_C_API 
void MW_CALL_CONV TOMLAB_exportPrintStackTrace(void) 
{
  char** stackTrace;
  int stackDepth = mclGetStackTrace(&stackTrace);
  int i;
  for(i=0; i<stackDepth; i++)
  {
    mclWrite(2 /* stderr */, stackTrace[i], sizeof(char)*strlen(stackTrace[i]));
    mclWrite(2 /* stderr */, "\n", sizeof(char)*strlen("\n"));
  }
  mclFreeStackTrace(&stackTrace, stackDepth);
}


LIB_TOMLAB_export_C_API 
bool MW_CALL_CONV mlxTOMLAB_export(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
  return mclFeval(_mcr_inst, "TOMLAB_export", nlhs, plhs, nrhs, prhs);
}

LIB_TOMLAB_export_C_API 
bool MW_CALL_CONV mlxNlp_cdcS(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
  return mclFeval(_mcr_inst, "nlp_cdcS", nlhs, plhs, nrhs, prhs);
}

LIB_TOMLAB_export_C_API 
bool MW_CALL_CONV mlxNlp_fg(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
  return mclFeval(_mcr_inst, "nlp_fg", nlhs, plhs, nrhs, prhs);
}

LIB_TOMLAB_export_C_API 
bool MW_CALL_CONV mlxKtr_grad(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
  return mclFeval(_mcr_inst, "ktr_grad", nlhs, plhs, nrhs, prhs);
}

LIB_TOMLAB_export_C_API 
bool MW_CALL_CONV mlfTOMLAB_export(int nargout, mxArray** x, mxArray** fval, mxArray* 
                                   fun, mxArray* grad, mxArray* hess, mxArray* 
                                   hessPattern, mxArray* x0, mxArray* linA, mxArray* 
                                   linB, mxArray* nonlconPattern, mxArray* nonlcon, 
                                   mxArray* nonlcon_grad, mxArray* eqConNum, mxArray* 
                                   neqConNum)
{
  return mclMlfFeval(_mcr_inst, "TOMLAB_export", nargout, 2, 12, x, fval, fun, grad, hess, hessPattern, x0, linA, linB, nonlconPattern, nonlcon, nonlcon_grad, eqConNum, neqConNum);
}

LIB_TOMLAB_export_C_API 
bool MW_CALL_CONV mlfNlp_cdcS(int nargout, mxArray** Mode, mxArray** c, mxArray** z, 
                              mxArray* x, mxArray* Prob, mxArray* Mode_in1, mxArray* 
                              nState)
{
  return mclMlfFeval(_mcr_inst, "nlp_cdcS", nargout, 3, 4, Mode, c, z, x, Prob, Mode_in1, nState);
}

LIB_TOMLAB_export_C_API 
bool MW_CALL_CONV mlfNlp_fg(int nargout, mxArray** Mode, mxArray** f, mxArray** g, 
                            mxArray* x, mxArray* Prob, mxArray* Mode_in1, mxArray* nState)
{
  return mclMlfFeval(_mcr_inst, "nlp_fg", nargout, 3, 4, Mode, f, g, x, Prob, Mode_in1, nState);
}

LIB_TOMLAB_export_C_API 
bool MW_CALL_CONV mlfKtr_grad(int nargout, mxArray** g, mxArray** dc, mxArray* x, 
                              mxArray* Prob)
{
  return mclMlfFeval(_mcr_inst, "ktr_grad", nargout, 2, 2, g, dc, x, Prob);
}

