/*
 * MATLAB Compiler: 5.1 (R2014a)
 * Date: Thu Oct 30 13:52:39 2014
 * Arguments: "-B" "macro_default" "-l" "fminunc_export.m" 
 */

#ifndef __fminunc_export_h
#define __fminunc_export_h 1

#if defined(__cplusplus) && !defined(mclmcrrt_h) && defined(__linux__)
#  pragma implementation "mclmcrrt.h"
#endif
#include "mclmcrrt.h"
#ifdef __cplusplus
extern "C" {
#endif

#if defined(__SUNPRO_CC)
/* Solaris shared libraries use __global, rather than mapfiles
 * to define the API exported from a shared library. __global is
 * only necessary when building the library -- files including
 * this header file to use the library do not need the __global
 * declaration; hence the EXPORTING_<library> logic.
 */

#ifdef EXPORTING_fminunc_export
#define PUBLIC_fminunc_export_C_API __global
#else
#define PUBLIC_fminunc_export_C_API /* No import statement needed. */
#endif

#define LIB_fminunc_export_C_API PUBLIC_fminunc_export_C_API

#elif defined(_HPUX_SOURCE)

#ifdef EXPORTING_fminunc_export
#define PUBLIC_fminunc_export_C_API __declspec(dllexport)
#else
#define PUBLIC_fminunc_export_C_API __declspec(dllimport)
#endif

#define LIB_fminunc_export_C_API PUBLIC_fminunc_export_C_API


#else

#define LIB_fminunc_export_C_API

#endif

/* This symbol is defined in shared libraries. Define it here
 * (to nothing) in case this isn't a shared library. 
 */
#ifndef LIB_fminunc_export_C_API 
#define LIB_fminunc_export_C_API /* No special import/export declaration */
#endif

extern LIB_fminunc_export_C_API 
bool MW_CALL_CONV fminunc_exportInitializeWithHandlers(
       mclOutputHandlerFcn error_handler, 
       mclOutputHandlerFcn print_handler);

extern LIB_fminunc_export_C_API 
bool MW_CALL_CONV fminunc_exportInitialize(void);

extern LIB_fminunc_export_C_API 
void MW_CALL_CONV fminunc_exportTerminate(void);



extern LIB_fminunc_export_C_API 
void MW_CALL_CONV fminunc_exportPrintStackTrace(void);

extern LIB_fminunc_export_C_API 
bool MW_CALL_CONV mlxFminunc_export(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[]);



extern LIB_fminunc_export_C_API bool MW_CALL_CONV mlfFminunc_export(int nargout, mxArray** x, mxArray** fval, mxArray* fun, mxArray* x0);

#ifdef __cplusplus
}
#endif
#endif
