/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "..\SSSLib\SSSLibOGL\SSSMesh.h"
#include "..\SSSLib\SSSFunc.h"

using namespace SSSLib;

int main(int argc, char* argv[])
{
	SSSMesh mesh0;
	mesh0.LoadObj(argv[1]);
	Vec3d low;
	Vec3d high;
	mesh0.ComputeBB(low, high);
	Vec3d delta = high-low;
	double maxDim = Max(delta[0], Max(delta[1], delta[2]));
	mesh0.Scale(Vec3d(1/maxDim, 1/maxDim, 1/maxDim));
	mesh0.WriteObj(argv[2]);
	return 0;
}