/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once
#include "SSSFunc.h"

namespace SSSLib
{
	template <typename t_val, typename t_vec1, typename t_vec2>
	t_val crossArea(t_vec1 iVec1, t_vec2 iVec2)
	{
		return iVec1[0] * iVec2[1] - iVec1[1] * iVec2[0];
	}
	//template <typename t_val, typename t_vec, typename t_coord>
	//t_val crossArea(t_vec1 iVec, int iSize, t_coord iX, t_coord iY)
	//{
	//	t_val retVal = 0;
	//	for (int i=0; i<iSize; i++)
	//		retVal += iVec[i]
	//}
}