/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "OGLTextureDisplay.h"

using namespace SSSLib;

void OGLTextureDisplay::DisplayFunc()
{
	if (mUsingPt)
	{
		mTex.Bind(false);
		OGLCheckError();

		glBegin(GL_QUADS);
			//glColor4ub(0,255,0,255);
			glTexCoord2f(1.0f, 0.0f);		glVertex2f(mPt[0][0], mPt[0][1]);
			glTexCoord2f(0.0f, 0.0f);		glVertex2f(mPt[1][0], mPt[1][1]);
			glTexCoord2f(0.0f, 1.0f);		glVertex2f(mPt[2][0], mPt[2][1]);
			glTexCoord2f(1.0f, 1.0f);		glVertex2f(mPt[3][0], mPt[3][1]);
		glEnd();
	}
	else
		mTex.Draw(mTop, mLeft, mButton, mRight);
	OGLCheckError();
}