/*Copyright (C) 2016 Yahan Zhou

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "..\ADMMLib\XNode.h"
#include "..\SSSLib\SSSSmallVec.h"

namespace ADMMLib
{

class XNodeFSum : public XNode
{
public:
	XNodeFSum(void);
	~XNodeFSum(void);

	SVec2Float mExtF;
	std::vector<SVec2Float> mtF;
	std::vector<SVec2Float> mtF0;
	std::vector<SVec2Float> mtRho;
	std::vector<SSSLib::Vec2b> mtFixed;

	virtual void Init();
	virtual void SolveX();
	
	void Encode();
	void Decode();
};

}