//
// MATLAB Compiler: 5.1 (R2014a)
// Date: Fri Oct 31 17:19:20 2014
// Arguments: "-B" "macro_default" "-W" "cpplib:TOMLAB_export" "-T" "link:lib"
// "TOMLAB_export" "nlp_cdcS" 
//

#include <stdio.h>
#define EXPORTING_TOMLAB_export 1
#include "TOMLAB_export.h"

static HMCRINSTANCE _mcr_inst = NULL;


#if defined( _MSC_VER) || defined(__BORLANDC__) || defined(__WATCOMC__) || defined(__LCC__)
#ifdef __LCC__
#undef EXTERN_C
#endif
#include <windows.h>

static char path_to_dll[_MAX_PATH];

BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, void *pv)
{
    if (dwReason == DLL_PROCESS_ATTACH)
    {
        if (GetModuleFileName(hInstance, path_to_dll, _MAX_PATH) == 0)
            return FALSE;
    }
    else if (dwReason == DLL_PROCESS_DETACH)
    {
    }
    return TRUE;
}
#endif
#ifdef __cplusplus
extern "C" {
#endif

static int mclDefaultPrintHandler(const char *s)
{
  return mclWrite(1 /* stdout */, s, sizeof(char)*strlen(s));
}

#ifdef __cplusplus
} /* End extern "C" block */
#endif

#ifdef __cplusplus
extern "C" {
#endif

static int mclDefaultErrorHandler(const char *s)
{
  int written = 0;
  size_t len = 0;
  len = strlen(s);
  written = mclWrite(2 /* stderr */, s, sizeof(char)*len);
  if (len > 0 && s[ len-1 ] != '\n')
    written += mclWrite(2 /* stderr */, "\n", sizeof(char));
  return written;
}

#ifdef __cplusplus
} /* End extern "C" block */
#endif

/* This symbol is defined in shared libraries. Define it here
 * (to nothing) in case this isn't a shared library. 
 */
#ifndef LIB_TOMLAB_export_C_API
#define LIB_TOMLAB_export_C_API /* No special import/export declaration */
#endif

LIB_TOMLAB_export_C_API 
bool MW_CALL_CONV TOMLAB_exportInitializeWithHandlers(
    mclOutputHandlerFcn error_handler,
    mclOutputHandlerFcn print_handler)
{
    int bResult = 0;
  if (_mcr_inst != NULL)
    return true;
  if (!mclmcrInitialize())
    return false;
  if (!GetModuleFileName(GetModuleHandle("TOMLAB_export"), path_to_dll, _MAX_PATH))
    return false;
    {
        mclCtfStream ctfStream = 
            mclGetEmbeddedCtfStream(path_to_dll);
        if (ctfStream) {
            bResult = mclInitializeComponentInstanceEmbedded(   &_mcr_inst,
                                                                error_handler, 
                                                                print_handler,
                                                                ctfStream);
            mclDestroyStream(ctfStream);
        } else {
            bResult = 0;
        }
    }  
    if (!bResult)
    return false;
  return true;
}

LIB_TOMLAB_export_C_API 
bool MW_CALL_CONV TOMLAB_exportInitialize(void)
{
  return TOMLAB_exportInitializeWithHandlers(mclDefaultErrorHandler, 
                                             mclDefaultPrintHandler);
}

LIB_TOMLAB_export_C_API 
void MW_CALL_CONV TOMLAB_exportTerminate(void)
{
  if (_mcr_inst != NULL)
    mclTerminateInstance(&_mcr_inst);
}

LIB_TOMLAB_export_C_API 
void MW_CALL_CONV TOMLAB_exportPrintStackTrace(void) 
{
  char** stackTrace;
  int stackDepth = mclGetStackTrace(&stackTrace);
  int i;
  for(i=0; i<stackDepth; i++)
  {
    mclWrite(2 /* stderr */, stackTrace[i], sizeof(char)*strlen(stackTrace[i]));
    mclWrite(2 /* stderr */, "\n", sizeof(char)*strlen("\n"));
  }
  mclFreeStackTrace(&stackTrace, stackDepth);
}


LIB_TOMLAB_export_C_API 
bool MW_CALL_CONV mlxTOMLAB_export(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
  return mclFeval(_mcr_inst, "TOMLAB_export", nlhs, plhs, nrhs, prhs);
}

LIB_TOMLAB_export_C_API 
bool MW_CALL_CONV mlxNlp_cdcS(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
  return mclFeval(_mcr_inst, "nlp_cdcS", nlhs, plhs, nrhs, prhs);
}

LIB_TOMLAB_export_CPP_API 
void MW_CALL_CONV TOMLAB_export(int nargout, mwArray& x, mwArray& fval, const mwArray& 
                                fun, const mwArray& grad, const mwArray& hess, const 
                                mwArray& hessPattern, const mwArray& x0, const mwArray& 
                                linA, const mwArray& linB, const mwArray& nonlconPattern, 
                                const mwArray& nonlcon, const mwArray& nonlcon_grad, 
                                const mwArray& eqConNum, const mwArray& neqConNum)
{
  mclcppMlfFeval(_mcr_inst, "TOMLAB_export", nargout, 2, 12, &x, &fval, &fun, &grad, &hess, &hessPattern, &x0, &linA, &linB, &nonlconPattern, &nonlcon, &nonlcon_grad, &eqConNum, &neqConNum);
}

LIB_TOMLAB_export_CPP_API 
void MW_CALL_CONV nlp_cdcS(int nargout, mwArray& Mode, mwArray& c, mwArray& z, const 
                           mwArray& x, const mwArray& Prob, const mwArray& Mode_in1, 
                           const mwArray& nState)
{
  mclcppMlfFeval(_mcr_inst, "nlp_cdcS", nargout, 3, 4, &Mode, &c, &z, &x, &Prob, &Mode_in1, &nState);
}

